; $Id: pan_kohlrausch.pro,v 1.2 2002/09/24 17:02:56 dimeo Exp $
;;;;;;;;;;;;;;;;;;;;
function pan_kohlrausch,x,parms, $
						parmnames = parmnames, $
						canDraw = canDraw, $
						drawMessage = drawMessage, $
						_Extra = extra

if n_params() eq 0 then begin
  parmnames = ['area','beta','tau']
  return,-1
endif
canDraw = 1

drawMessage = strarr(4)
drawMessage[0:1] = ['Hold left mouse button down','and drag to change amplitude']
drawMessage[2:3] = ['Hold left mouse button down','and drag to change width']

npts = n_elements(x)
amp = parms[0]
beta = abs(parms[1])
; The following line used to be tau = abs(parms[2]) and the next line is new (08/22/02)
tauave = abs(parms[2])
tau = beta*tauave/gamma(1.0/beta)

xtab = *extra.extra.xtabPtr
ytab = *extra.extra.ytabPtr
btab = *extra.extra.btabPtr
ttab = *extra.extra.ttabPtr

xTabLo = min(xtab)
xTabHi = max(xtab)
dxTab = xtab[1]-xtab[0]
xIndex = dblarr(npts)
xIndex = (x-xTabLo)/dxTab

bTabLo = min(btab)
bTabHi = max(btab)
dbTab = btab[1]-btab[0]
bIndex = (beta-bTabLo)/dbTab

tTabLo = min(ttab)
tTabHi = max(ttab)
dtTab = ttab[1]-ttab[0]
tIndex = (tau-tTabLo)/dtTab

hbar = 0.6528
if beta eq 1.0 then begin
  gam = 1.0*hbar/tau
  yout = (amp*gam/!dpi)/(x^2+gam^2)
endif else begin
  yout = amp*interpolate(ytab,xIndex,bIndex,tIndex,/grid)
endelse
return,yout
end