;$Id: trifenestra_sysvars.pro,v 1.8 2002/09/17 14:56:42 jmspark Exp $
pro trifenestra_sysvars_cleanup

	idl_state_restore, !trifenestra.idl_state
	message, 'Cleaning Up !trifenestra...', /continue
	; pointer_recursive_cleanup, !trifenestra

end

pro trifenestra_sysvars

	defsysv, '!trifenestra', exists=exists
	if exists then return

	defsysv, '!trifenestra', $
		{ version:2.05 $							; Trifenestra Version Number.
		, date:'2002.09.16' $
		, internal:0B $								; Toggle switch for the development version.

		, plotPosition:[.23,.2,.88,.9] $
		, printerPosition:[.15,.15,.8,.85] $

		, available_cmds:[ 'open' $
			, 'set' $
			, 'sum' $
			, 'integrate_2d' $
			, 'log' $
			, 'exit'$
			, 'help' ] $

		, idl_state:idl_state_save() $

		, self:obj_new() $							; Trifenestra itself.

		; *** Data Memory Space
		, DavePtr:ptr_new(/allocate_heap) $			; Dave pointer to be used during transactions.
		, oDave:obj_new('oDave') $					; Dave object that is being displayed.
		, oCopy:obj_new('oDave') $					; Copy of oDave so that we can go back.
		, oMemory:obj_new('oRAM', max=32) $

		; *** Main Window Attributes
		, wTrife:0L $								; Main Trifenestra Window ID

		, mainWindowCharSize:1.3 $											;
		, mainWindowState:idl_state_save() $		;
		, leftPanelState:idl_state_save() $
		, bottomPanelState:idl_state_save() $

		; *** Command Window Attributes
		, wCommandWindow:0L $						; Widget ID
		, CommandQueue:obj_new('oQueue') $			; The command queue.
		, CommandTrash:obj_new('oQueue', /open ) $	; Exectued commands are stored here.

		; --- Command Log Widget Attributes
		, wCommandLog:0L $							; Command Log Widget ID
		, CommandLogXSize: 80 $
		, CommandLogYSize: 25 $
		, CommandLogPos:0L $						; The line number of the command log.

		, wControlWindow:0L $

		; , wIDs:obj_new('oHash', null = 0L) $		; Storage for the widget IDs.

		}

	device, decomposed = 0
	loadct, 39

end